creview outEnrIntSpcCondWA[cr,cbt,ceeusc,ts][]

if $history == false
	say ("This view requires a history.")
	listen ("                           >>>>> return to continue ",$continue)
	quit (-1)
endif
if $background == false
	say ("This view requires a background.")
	listen ("                           >>>>> return to continue ",$continue)
	quit (-1)
endif

! TEMPLATE - CHANGE HERE
string $viewDesc = "view comOutEnrIntNonSpcCondProj: "
local varHis[upperdims,timeseq] =outEnrIntSpcCondWA[cr,cbt,ceeusc,ts][1]
local varBckGnd[upperdims,timeseq] =outEnrIntSpcCondWA[cr,cbt,ceeusc,ts][2]
local varResult[upperdims,timeseq] =outEnrIntSpcCondWA[cr,cbt,ceeusc,ts][3]
integer $timeDim = 4
! TEMPLATE - END CHANGE HERE

integer $timeStart, $timeEnd
getobjinfo (varResult[upperdims,timeseq], $timeStart; info=sequenceStart, dim=time)
getobjinfo (varResult[upperdims,timeseq], $timeEnd; info=sequenceEnd, dim=time)

integer $numChoices = 4
boolean $choices[$numChoices]
string $choiceStrs[$numChoices]
$choiceStrs[1] = "saturated projection (default)"
$choiceStrs[2] = "scurve to some percentage from last year of history"
$choiceStrs[3] = "stepwise percent change various source options"
$choiceStrs[4] = "specify and apply growthrate to last year of history"

localinformant boundsInfoSet[] = create (; object=set, \
	desc="defaults wrt bounds checking", \
	elemName1 = "setMax", \
	elemName2 = "maxVal", \
	elemName3 = "setMin", \
	elemName4 = "minVal")
		
menu ("Which way do you want to project?", $numChoices, \
	$choiceStrs[], $choices[]; defaultChoice=1, oneChoice=true)

if ($choices[1] == true)
	say ("projecting with method ", $choiceStrs[1])
	buildstring ($viewDesc, $viewDesc," proj method:: ", $choiceStrs[1])
	say ("")
	say ($choiceStrs[1])
	say ("")
	
	local yearInfoForProj[yearInfoSet] = create (; dim=yearInfoSet, dataType=integer)
	yearInfoForProj[yearInfoSet] = insert (1982; yearInfoSet:min)
	yearInfoForProj[yearInfoSet] = insert (2000; yearInfoSet:max)
	yearInfoForProj[yearInfoSet] = insert (1990; yearInfoSet:default)
	yearInfoForProj[yearInfoSet] = insert ($timeDim; yearInfoSet:timeDimNum)
	
	local boundsChecking[boundsInfoSet] = create (; dim=boundsInfoSet)
	boundsChecking[boundsInfoSet] = insert (0.0; boundsInfoSet:setMax)
	boundsChecking[boundsInfoSet] = insert (0.0; boundsInfoSet:maxVal)
	boundsChecking[boundsInfoSet] = insert (1.0; boundsInfoSet:setMin)
	boundsChecking[boundsInfoSet] = insert (0.0; boundsInfoSet:minVal)
	
	local normInfo[normInfoSet] = create (; dim=normInfoSet, dataType=integer)
	normInfo[yearInfoSet] = insert (0; normInfoSet:doRenorm)
	normInfo[yearInfoSet] = insert (0; normInfoSet:normDimNum)
	
	local percentChgFromLYHis[] = create (; data=25.0)
	
 	local defaultJoin[] = create (; data=3) ! join history
	
	local firstHisYearForProjection[], asymtoticPercentChange[], joinMethod[]
	
	tool $informPath/satProjFromHist.t \
			yearInfoForProj[yearInfoSet] \
			boundsChecking[boundsInfoSet] \
			normInfo[normInfoSet] \
			percentChgFromLYHis[] \
			defaultJoin[] \
			varHis[upperdims,timeseq] \
			varResult[upperdims,timeseq] \
			firstHisYearForProjection[] \
			asymtoticPercentChange[] \
			joinMethod[]
	
	integer $firstHisYearForProjection
	getobjinfo (firstHisYearForProjection[], $firstHisYearForProjection; info=dataElement)
	buildstring ($viewDesc,$viewDesc,"first year of history for projection = ",$firstHisYearForProjection,": ")
	
	string $asymtoticPercentChange
	getobjinfo (asymtoticPercentChange[], $asymtoticPercentChange; info=dataElement)
	buildstring ($viewDesc,$viewDesc,"asymtotic percent change = ",$asymtoticPercentChange,": ")
	
	integer $joinMethod
	getobjinfo (joinMethod[], $joinMethod; info=dataElement)
	if $joinMethod == 1
		buildstring ($viewDesc,$viewDesc,"join to projection of last 2 years of history")
	endif
	if $joinMethod == 2
		buildstring ($viewDesc,$viewDesc,"join to trend line")
	endif
	if $joinMethod == 3
		buildstring ($viewDesc,$viewDesc,"join to trend projection of last history year")
	endif
endif	

if ($choices[2] == true)
	say ("")
	say ("projecting with method ", $choiceStrs[2])
	say ("")

	integer $startTransitionYear	
	listen ("  What is the start year of the transition? {2010,..}[2015] ",$startTransitionYear)
	if $startTransitionYear == 0
		$startTransitionYear = 2015
	endif
	if $startTransitionYear < 2010
		$startTransitionYear = 2010
	endif

	integer $duration
	say ("")
	listen ("  What is the duration of the transition in years? {15,..}[15] ",$duration)
	if $duration == 0
		$duration = 15
	endif

	buildstring ($viewDesc, $viewDesc," proj method: ", $choiceStrs[2])
	string $percentageChg
	listen ("  What is the percentage change (pos for increase neg for decrease)? {-100,..,100}[-15] ",$percentageChg)
	if $percentageChg == ""
		$percentageChg = "-15"
	endif

	local fractionalChange[] = create (; data=$percentageChg) / 100
	
	local rightAssympt[] = 1 + fractionalChange[]
	
	local curveWidth[] = create (; entity=year, data=$duration)
	local inflectionPt[] = curveWidth[] / 2
	local multiplierightAssymptx[t] = create (; dim=SEQ;time:$timeStart:$timeEnd:1;year)
	multiplierightAssymptx[t] = insert (scurve (inflectionPt[], curveWidth[]; end=$duration, name=time, interval=year, leftAsym=1, rightAsym=rightAssympt[]); time->time:$startTransitionYear)
	multiplierightAssymptx[t] = insert (1.0; time:+0)
	multiplierightAssymptx[t] = insert (rightAssympt[]; time:-0)
	local multiplierightAssympt[t] = linint (multiplierightAssymptx[t])
	varResult[upperdims,timeseq] = extract (varHis[upperdims,timeseq]; time:-0, shrink=on) * multiplierightAssympt[t]

endif

if ($choices[3] == true)
	say ("")
	say ("projecting with method ", $choiceStrs[3])
	say ("")

	buildstring ($viewDesc, $viewDesc," proj method: ", $choiceStrs[3])
	
	local transYears_bck[e] = create (; dim=SEQ;event:1:5:1;event, \
			data="2025.0 2050.0 2075.0 0.0 0.0")
	local transYears[e] = copyshape (transYears_bck[e])
	transYears[e] = table (; with=transYears_bck[e], title="enter your years for transitions")
			
	local percentageChg_bck[e]  = create (; dim=SEQ;event:1:5:1;event, \
			data="-20.0 -40.0 -50.0 0.0 0.0")
	local percentageChg[e] = copyshape (percentageChg_bck[e])
	percentageChg[e] = table (; with=percentageChg_bck[e], title="enter percentage change (pos for increase neg for decrease) ")
	
	local boundsChecking[boundsInfoSet] = create (; dim=boundsInfoSet)
	boundsChecking[boundsInfoSet] = insert (0.0; boundsInfoSet:setMax)
	boundsChecking[boundsInfoSet] = insert (0.0; boundsInfoSet:maxVal)
	boundsChecking[boundsInfoSet] = insert (1.0; boundsInfoSet:setMin)
	boundsChecking[boundsInfoSet] = insert (0.0; boundsInfoSet:minVal)
	
	tool $informPath/stepwiseChange.t \
			transYears[e] \
			percentageChg[e] \
			varHis[upperdims,timeseq] \
			varBckGnd[upperdims,timeseq] \
			boundsChecking[boundsInfoSet] \
			varResult[upperdims,timeseq] 
			
endif

if ($choices[4] == true)
	say ("")
	say ("projecting with method ", $choiceStrs[4])
	say ("")

	buildstring ($viewDesc, $viewDesc," proj method: ", $choiceStrs[3])
	
	local growthRate_bck[t] = create (; dim=SEQ;time:$timeStart:$timeEnd:1;year, data=0.01)
	local growthRate[t] = copyshape (growthRate_bck[t])
	growthRate[t] = table (; with=growthRate_bck[t], title="enter the desired growthrate as a decimal type percent {-1.0,..,1.0}[0.01]")

	local varHisLastYear[upperdims,timeseq]= extract (varHis[upperdims,timeseq]; time:-0, shrink=on)
	varResult[upperdims,timeseq] = cumprod (growthRate[t] + 1.0) * varHisLastYear[upperdims,timeseq] 
	
	
endif

! TEMPLATE - CHANGE HERE
outEnrIntSpcCondWA[cr,cbt,ceeusc,ts][3] = changeshape (varResult[upperdims,timeseq];  desc=$viewDesc)
! TEMPLATE - END CHANGE HERE

boolean $seeResults
say ("")
listen ("Do you want to see results? {y n}[n] ",$seeResults)
if $seeResults == true
! TEMPLATE - CHANGE HERE
	graph (outEnrIntSpcCondWA[cr,cbt,ceeusc,ts][all]; \ 
! TEMPLATE - END CHANGE HERE
			objColours=$scnColours[all], \	
			legTitles=$scnDescs[all])
endif
