creview	newWatHeaterShr[cr,dts,wht->whft,ts][]

if $history == false
	say ("This view requires a history.")
	listen ("                           >>>>> return to continue ",$continue)
	quit (-1)
endif
if $background == false
	say ("This view requires a background.")
	listen ("                           >>>>> return to continue ",$continue)
	quit (-1)
endif

! TEMPLATE - CHANGE HERE
string $viewDesc = "view newWatHeaterShr: "
local varHis[upperdims,timeseq] = newWatHeaterShr[cr,dts,wht->whft,ts][1]
local varBckGnd[upperdims,timeseq] = newWatHeaterShr[cr,dts,wht->whft,ts][2]
local varResult[upperdims,timeseq] = newWatHeaterShr[cr,dts,wht->whft,ts][3]
integer $timeDim = 4
integer $normDim = 3
! TEMPLATE - END CHANGE HERE
integer $timeStart, $timeEnd
getobjinfo (varResult[upperdims,timeseq], $timeStart; info=sequenceStart, dim=time)
getobjinfo (varResult[upperdims,timeseq], $timeEnd; info=sequenceEnd, dim=time)

integer $numChoices = 2
boolean $choices[$numChoices]
string $choiceStrs[$numChoices]
$choiceStrs[1] = "saturated projection (default)"
$choiceStrs[2] = "share substitution"

localinformant boundsInfoSet[] = create (; object=set, \
	desc="defaults wrt bounds checking", \
	elemName1 = "setMax", \
	elemName2 = "maxVal", \
	elemName3 = "setMin", \
	elemName4 = "minVal")
		
menu ("Which way do you want to project?", $numChoices, \
	$choiceStrs[], $choices[]; defaultChoice=1, oneChoice=true)	


if $choices[1] == true
	say ("projecting with method ", $choiceStrs[1])
	buildstring ($viewDesc, $viewDesc," proj method:: ", $choiceStrs[1])
	
	local yearInfoForProj[yearInfoSet] = create (; dim=yearInfoSet, dataType=integer)
	yearInfoForProj[yearInfoSet] = insert (1978; yearInfoSet:min)
	yearInfoForProj[yearInfoSet] = insert (2006; yearInfoSet:max)
	yearInfoForProj[yearInfoSet] = insert (1978; yearInfoSet:default)
	yearInfoForProj[yearInfoSet] = insert ($timeDim; yearInfoSet:timeDimNum)
	
	local boundsChecking[boundsInfoSet] = create (; dim=boundsInfoSet)
	boundsChecking[boundsInfoSet] = insert (1.0; boundsInfoSet:setMax)
	boundsChecking[boundsInfoSet] = insert (1.0; boundsInfoSet:maxVal)
	boundsChecking[boundsInfoSet] = insert (1.0; boundsInfoSet:setMin)
	boundsChecking[boundsInfoSet] = insert (0.0; boundsInfoSet:minVal)
	
	local normInfo[normInfoSet] = create (; dim=normInfoSet, dataType=integer)
	normInfo[yearInfoSet] = insert (1; normInfoSet:doRenorm)
	normInfo[yearInfoSet] = insert ($normDim; normInfoSet:normDimNum)
	
	local percentChgFromLYHis[] = create (; data=50.0)
	
 	local defaultJoin[] = create (; data=2) ! join trend
	
	local firstHisYearForProjection[], asymtoticPercentChange[], joinMethod[]
	
	tool $informPath/satProjFromHist.t \
			yearInfoForProj[yearInfoSet] \
			boundsChecking[boundsInfoSet] \
			normInfo[normInfoSet] \
			percentChgFromLYHis[] \
			defaultJoin[] \
			varHis[upperdims,timeseq] \
			varResult[upperdims,timeseq] \
			firstHisYearForProjection[] \
			asymtoticPercentChange[] \
			joinMethod[]
	
	integer $firstHisYearForProjection
	getobjinfo (firstHisYearForProjection[], $firstHisYearForProjection; info=dataElement)
	buildstring ($viewDesc,$viewDesc,"first year of history for projection = ",$firstHisYearForProjection,": ")
	
	string $asymtoticPercentChange
	getobjinfo (asymtoticPercentChange[], $asymtoticPercentChange; info=dataElement)
	buildstring ($viewDesc,$viewDesc,"asymtotic percent change = ",$asymtoticPercentChange,": ")
	
	integer $joinMethod
	getobjinfo (joinMethod[], $joinMethod; info=dataElement)
	if $joinMethod == 1
		buildstring ($viewDesc,$viewDesc,"join to projection of last 2 years of history")
	endif
	if $joinMethod == 2
		buildstring ($viewDesc,$viewDesc,"join to trend line")
	endif
	if $joinMethod == 3
		buildstring ($viewDesc,$viewDesc,"join to trend projection of last history year")
	endif

endif

if $choices[2] == true
	say ("projecting with method ", $choiceStrs[2])
	buildstring ($viewDesc, $viewDesc," proj method:: ", $choiceStrs[2])

	localinformant startAndEndYear[]
	startAndEndYear[] = create (; object=set, data="startYear endYear")
	
	localinformant askOptions[]
	askOptions[] = create (; object=set, data="preamble years shares seeResult")

	local yearDefaults[seyr] = create (; dim=startAndEndYear, dataType=integer, data=0)
	local transShrDefault[upperDims,shrDim] = extract (varBckGnd[upperdims,timeseq]; time:+0, shrink=on)
	local normDimNum[] = create(; dataType=integer, data=$normDim)
	local askSettings[ao] = create(; dim=askOptions, dataType=integer, data="1, 1, 1, 0")
	
	tool $informPath/shrSubstitution.t \
			yearDefaults[seyr] \
			transShrDefault[upperDims,shrDim] \
			varBckGnd[upperdims,timeseq] \
			normDimNum[] \
			askSettings[qo] \
			varResult[upperdims,timeseq]
endif

! TEMPLATE - CHANGE HERE
newWatHeaterShr[cr,dts,wht->whft,ts][3] = changeshape (varResult[upperdims,timeseq]; desc=$viewDesc)
! TEMPLATE - END CHANGE HERE

boolean $seeResults
say ("")
listen ("Do you want to see results? {y n}[n] ",$seeResults)
if $seeResults == true
! TEMPLATE - CHANGE HERE
	graph (newWatHeaterShr[cr,dts,wht->whft,ts][all]; \ 
! TEMPLATE - END CHANGE HERE
			objColours=$scnColours[all], \	
			legTitles=$scnDescs[all])
endif

