input inputStringSet[] !$exportDataDir, $subjectArea
output exportDirSet[]

localinformant inputStringSetInf[]
inputStringSetInf[] = inputStringSet[]

!pull out the input strings
string $exportDataDir
getobjinfo (inputStringSetInf[], $exportDataDir; info=elementName, elementNum=1)

string $subjectArea
getobjinfo (inputStringSetInf[], $subjectArea; info=elementName, elementNum=2)

! get the project names from common location
local projectNamesSet[]
tool $informPath/getProjectNames.t \
		projectNamesSet[] 
localinformant projectNamesSetInf[]
projectNamesSetInf[] = projectNamesSet[]

integer $numProjects
getobjinfo (projectNamesSet[], $numProjects; info=extent)

string $projectName[$numProjects]
boolean $projectChoice[$numProjects]
integer $projectIter
for $projectIter from 1 upto $numProjects
	getobjinfo (projectNamesSetInf[], $projectName[$projectIter]; info=elementName, elementNum=$projectIter)
endfor

! get the model version from common location
local modelVersionSet[]
tool $informPath/getModelVersion.t \
		modelVersionSet[] 
localinformant modelVersionSetInf[]
modelVersionSetInf[] = modelVersionSet[]

string $modelVersion
getobjinfo (modelVersionSetInf[], $modelVersion; info=elementName, elementNum=1)

string $projectDir, $exportDataProjectPath, $exportDataProjectSubjectPath, $exportFileName
! END PROJECT Specific export prep

boolean $userChoseSomething = false
while ($userChoseSomething == false)
	say ("")
	menu ("Which project is this related to?  ", $numProjects, \
		$projectName[], $projectChoice[];  oneChoice=true)

	! double check the user choose something!
	for $projectIter from 1 upto $numProjects
		if ($projectChoice[$projectIter] == true)
			$userChoseSomething = true
		endif
	endfor
	if ($userChoseSomething == false)
		say ("")
		say ("There is no default please choose something from the list")
	endif	
endwhile
	
if ($projectChoice[$numProjects] == true)
	listen ("  What is the project name to use?  ", $projectDir)
else
	for $projectIter from 1 upto $numProjects
		if ($projectChoice[$projectIter] == true)
			$projectDir = $projectName[$projectIter]
		endif
	endfor
endif



buildstring ($projectDir, $projectDir, "_", $modelVersion, "/")

buildstring ($exportDataProjectPath, $exportDataDir, $projectDir)
createdir ($exportDataProjectPath)

buildstring ($exportDataProjectSubjectPath, $exportDataProjectPath, $subjectArea)
createdir ($exportDataProjectSubjectPath)

exportDirSet[] = create (; object=set, \
	elemName1=$exportDataProjectSubjectPath)
