input transYearsDefault[seyr] !integer
input transShrDefault[upperDims,shrDim] !real
input bgndShr[upperdims,shrDim,t] !real
input normDimNum[] !integer
input askSettings[ao] !integer 1 is be quiet and accept defaults 0 is ask questions
output newShr[upperdims,shrDim,t] !real

integer $normDimNum
getobjinfo (normDimNum[], $normDimNum; info=dataElement)

! Calling function must also create these local informants to inform as indicated in inputs
localinformant startAndEndYear[]
startAndEndYear[] = create (; object=set, data="startYear endYear")

localinformant askOptions[]
askOptions[] = create (; object=set, data="preamble years shares seeResult")

integer $startTime
getobjinfo (bgndShr[upperdims,shrDim,t], $startTime; info=sequenceStart, dim=time)

integer $askYears, $askShares, $askSeeResult, $doPreamble
getobjinfo (askSettings[qo], $doPreamble; info=dataElement, dim1=preamble)
getobjinfo (askSettings[qo], $askYears; info=dataElement, dim1=years)
getobjinfo (askSettings[qo], $askShares; info=dataElement, dim1=shares)
getobjinfo (askSettings[qo], $askSeeResult; info=dataElement, dim1=seeResult)

if ($doPreamble==1)
	say ("")
	say ("The user will specify the target market share for the systems of interest")
	say ("(leaving -1 for those that will float to absorb the difference).  The user")
	say ("will also specify the year shares start to deviate from the background scenario")
	say ("and the target year in which the target share should be achieved. This view")
	say ("will linearly move the shares to the target share starting in the given start year.")  
	say ("The systems not specified (set to -1) will absorb the changes prorata.")
	say ("")
	boolean $continue
	listen ("Press enter to continue>> ",$continue)
endif

local targetYrs_bck[seyr] = create (; dim=startAndEndYear, dataType=integer)

if $askYears==0
	local targetYrs[seyr] = transYearsDefault[seyr]
else
	targetYrs_bck[seyr] = insert ($startTime; startAndEndYear:startYear)
	targetYrs_bck[seyr] = insert (2050; startAndEndYear:endYear)

	local targetYrs[seyr] = copyshape (targetYrs_bck[seyr])
	targetYrs[seyr] = table (; with=targetYrs_bck[seyr], title="enter the years to start and complete the transition")
endif

integer $startYr, $targetYr
getobjinfo (targetYrs[seyr], $startYr; info=dataElement, dim1=startYear)
getobjinfo (targetYrs[seyr], $targetYr; info=dataElement, dim1=endYear)

if $askShares==0
	local targetShr[upperdims,shrDim] = transShrDefault[upperDims,shrDim]
else
	boolean $upperDimVariance
	say ("")
	listen ("Do you want to specify each upper dimension separately (a n reply means using same settings for all uper dimensons)? (y/n)[n] ", $upperDimVariance)
	say ("")
	
	local targetShr_bck[upperdims,shrDim] = extract (bgndShr[upperdims,shrDim,t]; \
		time:$targetYr, shrink=on)
	local targetShr[upperdims,shrDim] = copyshape (targetShr_bck[upperdims,shrDim])
	
	if ($upperDimVariance==false and $normDimNum > 1)
		if ($normDimNum==2)
			local targetShr_bckx[shrDim] = create (; dimFrom2=targetShr_bck[upperdims,shrDim], data=-1.0)
		else
			if ($normDimNum==3)
				local targetShr_bckx[shrDim] = create (; dimFrom3=targetShr_bck[upperdims,shrDim], data=-1.0)
			else
				if ($normDimNum==4)
					local targetShr_bckx[shrDim] = create (; dimFrom4=targetShr_bck[upperdims,shrDim], data=-1.0)
				else
					local targetShr_bckx[shrDim] = create (; dimFrom5=targetShr_bck[upperdims,shrDim], data=-1.0)
				endif
			endif
		endif
	
		local targetShrx[shrDim] = copyshape (targetShr_bckx[shrDim])
		targetShrx[shrDim] = table (; with=targetShr_bckx[shrDim], \
			title="enter the target share for the elements of interest and enter -1 for those that are flexible to absorb the change")
		targetShr[upperdims,shrDim] = insert (targetShrx[shrDim])
	else
		targetShr[upperdims,shrDim] = table (; with=targetShr_bck[upperdims,shrDim], \
			title="enter the target share for the elements of interest and enter -1 for those that are flexible to absorb the change")
	endif
endif

local isFlexElem[upperdims,shrDim] = booleq (targetShr[upperdims,shrDim], -1.0)
local isTargetElem[upperdims,shrDim] = 1 - isFlexElem[upperdims,shrDim] 
	
local redistribShr[upperdims,shrDim,tSyr] = norm (extract (bgndShr[upperdims,shrDim,t]; \
	time:$startYr..-0) * isFlexElem[upperdims,shrDim]; \
	dim=$normDimNum)

local zeroTargetAsSMALLNum[] = booleq (targetShr[upperdims,shrDim], 0) * 1e-6
local targetShry[upperdims,shrDim] = targetShr[upperdims,shrDim] + zeroTargetAsSMALLNum[]
targetShr[upperdims,shrDim] = targetShry[upperdims,shrDim]

local linIntSetup[upperdims,shrDim,tSyr] = extract (bgndShr[upperdims,shrDim,t]; time:$startYr..-0)
local zeroRange[upperdims,shrDim,tSyr] = extract (linIntSetup[upperdims,shrDim,tSyr];time:+1..-0)
zeroRange[upperdims,shrDim,tSyr] = 0.0
linIntSetup[upperdims,shrDim,tSyr] = insert (zeroRange[upperdims,shrDim,tSyr]; time->time:+1)
linIntSetup[upperdims,shrDim,tSyr] = insert (targetShr[upperdims,shrDim] * isTargetElem[upperdims,shrDim]; time:$targetYr)
local linIntTargetElems[upperdims,shrDim,tSyr] = linint (linIntSetup[upperdims,shrDim,tSyr]; \
	fixedEnd=on) * isTargetElem[upperdims,shrDim]

local residual[upperdims,tSyr] = sum (linIntTargetElems[upperdims,shrDim,tSyr]; dim=$normDimNum) * -1 + 1

newShr[upperdims,shrDim,t] = bgndShr[upperdims,shrDim,t]
local newShrx[upperdims,shrDim,t] = newShr[upperdims,shrDim,t]
newShrx[upperdims,shrDim,t] = insert (residual[upperdims,tSyr] * redistribShr[upperdims,shrDim,tSyr] + linIntTargetElems[upperdims,shrDim,tSyr]; \
	time->time:$startYr)
newShr[upperdims,shrDim,t] = norm (max (newShrx[upperdims,shrDim,t], 0); dim=$normDimNum)

if ($askSeeResult==1)
	boolean $seeResults
	say ("")
	listen ("Do you want to see your results? {y n}[n] ",$seeResults)
	if $seeResults == true
		graph (bgndShr[upperdims,shrDim,t], \
			newShr[upperdims,shrDim,t]; \
			title2="background share and new share")
	endif
endif

