input transYearsDefault[e] !real
input percentageChangeDefault[e] !real
input inEffVarHis[upperDims,ts]
input inEffVarBckGnd[upperDims,ts]
input boundsChecking[boundsInfoSet]
input quietUseDefaults[]
output outEffVar[upperDims,ts]

! Calling function must also create these local informants to inform as indicated in inputs
localinformant boundsInfoSet[] = create (; object=set, \
	desc="defaults wrt bounds checking", \
	elemName1 = "setMax", \
	elemName2 = "maxVal", \
	elemName3 = "setMin", \
	elemName4 = "minVal")

integer $setMax
real $maxVal
boolean $doMax = false
getobjinfo (boundsChecking[], $setMax; info=dataElement, dim1=setMax)
getobjinfo (boundsChecking[], $maxVal; info=dataElement, dim1=maxVal)
if ($setMax == 1)
	$doMax = true
endif

integer $setMin
real $minVal
boolean $doMin
getobjinfo (boundsChecking[], $setMin; info=dataElement, dim1=setMin)
getobjinfo (boundsChecking[], $minVal; info=dataElement, dim1=minVal)
if ($setMin == 1)
	$doMin = true
endif

integer $quietUseDefaults
getobjinfo (quietUseDefaults[], $quietUseDefaults; info=dataElement)

integer $firstScnYr, $firstScnYrM1
getobjinfo (outEffVar[upperDims,ts], $firstScnYr; info=sequenceStart, dim=time)
$firstScnYrM1 = $firstScnYr - 1

local oneEvent[e] = create (; dim=SEQ;event:1:5:1;event, data=1.0)

local transitionYear_bck[upperDims,e] = changeshape (copyshape (inEffVarHis[upperDims,ts]); \
	deleteDims:time, entity="-", SIuom="-", altUom="-") * oneEvent[e]
transitionYear_bck[upperDims,e] = insert (transYearsDefault[e])
local transitionYear[upperDims,e] = copyshape (transitionYear_bck[upperDims,e])
if $quietUseDefaults == 1
	transitionYear[upperDims,e] = transitionYear_bck[upperDims,e]
else
	transitionYear[upperDims,e] = table (; with=transitionYear_bck[upperDims,e], title="enter your year for transitions")
endif

local someTransition[upperDims] = boolgt (sum (transitionYear[upperDims,e]; dim=event), 0)

local percentageChange_bckx[upperDims,e] = copyshape (transitionYear_bck[upperDims,e])
percentageChange_bckx[upperDims,e] = insert (percentageChangeDefault[e])
local percentageChange_bck[upperDims,e] = percentageChange_bckx[upperDims,e] * someTransition[upperDims]
local percentageChange[upperDims,e] = copyshape (percentageChange_bck[upperDims,e])
if $quietUseDefaults == 1
	percentageChange[upperDims,e] = percentageChange_bck[upperDims,e]
else
	percentageChange[upperDims,e] = table (; with=percentageChange_bck[upperDims,e], title="enter transition percentage change (neg for decrease!)")
endif

local yearOfChange[upperDims], multiplierThisEvent[upperDims]
local prepLinIntAllEvents[upperDims,ts], prepLinIntAllEventsx[upperDims,ts], prepLinIntThisEvent[upperDims,ts]
prepLinIntAllEvents[upperDims,ts] = changeshape (copyshape (outEffVar[upperDims,ts]); entity="-", SIuom="-", altUom="-")
prepLinIntAllEvents[upperDims,ts] = 0.0

local one[upperDims,ts] = copyshape (prepLinIntAllEvents[upperDims,ts])
one[upperDims,ts] = 1.0

integer $i
for $i from 1 upto 5
	yearOfChange[upperDims] = extract (transitionYear[upperDims,e]; event:$i, shrink=on)
	multiplierThisEvent[upperDims] = extract (percentageChange[upperDims,e]; event:$i, shrink=on) / 100 + 1
	
	prepLinIntThisEvent[upperDims,ts] = booleq (cumsum (one[upperDims,ts]; \
		multiplyEntity=off) + $firstScnYrM1, \
		yearOfChange[upperDims]) * multiplierThisEvent[upperDims]
	
	prepLinIntAllEventsx[upperDims,ts] = prepLinIntAllEvents[upperDims,ts] + prepLinIntThisEvent[upperDims,ts]
	prepLinIntAllEvents[upperDims,ts] = prepLinIntAllEventsx[upperDims,ts]
endfor

prepLinIntAllEvents[upperDims,ts] = insert (1.0; time:+0)
local multiplierAllTime[upperDims,ts] = linint (prepLinIntAllEvents[upperDims,ts]; start=on, fixedEnd=on)

boolean $method[3]

if $quietUseDefaults == 0
	say ("")
	menu ("The change multiplier is calculated a linint between each event. What should the multiplier be used against", 3, \
		"each year of the background(default)", \
		"first year of background", \
		"last year of history", \
		$method[])
	say ("")
endif

if ($method[1] == false) and ($method[2] == false) and ($method[3] == false)
	$method[1] = true
endif
if $method[1] == true
	$method[2] = false
	$method[3] = false
endif
if $method[2] == true
	$method[3] = false
endif

local outEffVarCalc[upperDims,ts]
if ($method[1] == true)
	outEffVarCalc[upperDims,ts] = inEffVarBckGnd[upperDims,ts] * multiplierAllTime[upperDims,ts]
endif

if ($method[2] == true)
	local valFirstYrBgnd[upperDims] = extract (inEffVarBckGnd[upperDims,ts]; time:+0, shrink=on)
	outEffVarCalc[upperDims,ts] = valFirstYrBgnd[upperDims] * multiplierAllTime[upperDims,ts]
endif

if ($method[3] == true)
	local valLastYrHis[upperDims] = extract (inEffVarHis[upperDims,ts]; time:-0, shrink=on)
	outEffVarCalc[upperDims,ts] = valLastYrHis[upperDims] * multiplierAllTime[upperDims,ts]
endif

if ($doMax == true)
	local outEffVarx[upperDims,ts] = min (outEffVarCalc[upperDims,ts], $maxVal)
	outEffVarCalc[upperDims,ts] = outEffVarx[upperDims,ts]
endif

if ($doMin == true)
	local outEffVary[upperDims,ts] = max (outEffVarCalc[upperDims,ts], $minVal)
	outEffVarCalc[upperDims,ts] = outEffVary[upperDims,ts]
endif

local noTransitions[upperDims] = 1 - someTransition[upperDims]
local outEffVarNotChg[upperDims,ts] = inEffVarBckGnd[upperDims,ts] * noTransitions[upperDims]
outEffVar[upperDims,ts] = outEffVarCalc[upperDims,ts] * someTransition[upperDims] + outEffVarNotChg[upperDims,ts]


boolean $seeResults
say ("")
listen ("Do you want to see your results? {y n}[n] ",$seeResults)
if $seeResults == true
	graph (inEffVarHis[upperDims,ts], \
		inEffVarBckGnd[upperDims,ts], \
		outEffVar[upperDims,ts]; \
		title2="history and projection of efficiency")
endif

